Gecode::FlatZinc::IntBoolBrancher< Merit > Class Template Reference

Brancher for integer and Boolean views. More...

`#include <branch.hh>`

## Public Member Functions

virtual const Choice * | choice (Space &home)
| Return choice.
virtual Actor * | copy (Space &home)
| Perform cloning.
virtual size_t | dispose (Space &home)
| Delete brancher and return its size.
Public Member Functions inherited from Gecode::FlatZinc::IntBoolBrancherBase
virtual bool | status (const Space &home) const
| Check status of brancher, return true if alternatives left.
virtual const Choice * | choice (const Space &home, Archive &e)
| Return choice.
virtual ExecStatus | commit (Space &home, const Choice &c, unsigned int b)
| Perform commit for choice c and alternative b.
virtual NGL * | ngl (Space &home, const Choice &c, unsigned int b) const
| Create no-good literal for choice c and alternative b.
virtual void | print (const Space &home, const Choice &c, unsigned int b, std::ostream &o) const
| Print branch for choice c and alternative b.
unsigned int | id (void) const
| Return brancher id.
BrancherGroup | group (void) const
| Return group brancher belongs to.
void | group (BrancherGroup g)
| Add brancher to group g.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static void | post (Home home, ViewArray< Int::IntView > x, ViewArray< Int::BoolView > y, Merit &m, ValSelCommitBase< Int::IntView, int > *xvsc, ValSelCommitBase< Int::BoolView, int > *yvsc)
| Post brancher.
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| IntBoolBrancher (Space &home, IntBoolBrancher &b)
| Constructor for cloning b.
| IntBoolBrancher (Home home, ViewArray< Int::IntView > x, ViewArray< Int::BoolView > y, Merit &m, ValSelCommitBase< Int::IntView, int > *xvsc, ValSelCommitBase< Int::BoolView, int > *yvsc)
| Constructor for creation.
Protected Member Functions inherited from Gecode::FlatZinc::IntBoolBrancherBase
| IntBoolBrancherBase (Space &home, IntBoolBrancherBase &b)
| Constructor for cloning b.
| IntBoolBrancherBase (Home home, ViewArray< Int::IntView > x, ViewArray< Int::BoolView > y, ValSelCommitBase< Int::IntView, int > *xvsc, ValSelCommitBase< Int::BoolView, int > *yvsc)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Brancher
| Brancher (Home home)
| Constructor for creation.
| Brancher (Space &home, Brancher &b)
| Constructor for cloning b.

## Protected Attributes

Merit | merit
| Selection by maximal merit.
Protected Attributes inherited from Gecode::FlatZinc::IntBoolBrancherBase
ViewArray< Int::IntView > | x
| Integer views to branch on.
ViewArray< Int::BoolView > | y
| Boolean views to branch on.
int | start
| Unassigned views start here (might be in x or y).
ValSelCommitBase< Int::IntView, int > * | xvsc
| Integer value selection and commit object.
ValSelCommitBase< Int::BoolView, int > * | yvsc
| Boolean value selection and commit object.

## Detailed Description

template<class Merit>
class Gecode::FlatZinc::IntBoolBrancher< Merit >

Brancher for integer and Boolean views.

Definition at line 303 of file branch.hh.

## Constructor & Destructor Documentation

## IntBoolBrancher() [1/2]

template<class Merit>

Gecode::FlatZinc::IntBoolBrancher< Merit >::IntBoolBrancher | ( | Space & | home,
|  | IntBoolBrancher< Merit > & | b )

protected

Constructor for cloning b.

## IntBoolBrancher() [2/2]

template<class Merit>

Gecode::FlatZinc::IntBoolBrancher< Merit >::IntBoolBrancher | ( | Home | home,
|  | ViewArray< Int::IntView > | x,
|  | ViewArray< Int::BoolView > | y,
|  | Merit & | m,
|  | ValSelCommitBase< Int::IntView, int > * | xvsc,
|  | ValSelCommitBase< Int::BoolView, int > * | yvsc )

inline protected

Constructor for creation.

Definition at line 335 of file branch.hpp.

## Member Function Documentation

## choice()

template<class Merit>

const Choice * Gecode::FlatZinc::IntBoolBrancher< Merit >::choice | ( | Space & | home | ) |

virtual

Return choice.

Implements Gecode::FlatZinc::IntBoolBrancherBase.

Definition at line 371 of file branch.hpp.

## copy()

template<class Merit>

Actor * Gecode::FlatZinc::IntBoolBrancher< Merit >::copy | ( | Space & | home | ) |

virtual

Perform cloning.

Implements Gecode::Actor.

Definition at line 365 of file branch.hpp.

## post()

template<class Merit>

void Gecode::FlatZinc::IntBoolBrancher< Merit >::post | ( | Home | home,
|  | ViewArray< Int::IntView > | x,
|  | ViewArray< Int::BoolView > | y,
|  | Merit & | m,
|  | ValSelCommitBase< Int::IntView, int > * | xvsc,
|  | ValSelCommitBase< Int::BoolView, int > * | yvsc )

inline static

Post brancher.

Definition at line 346 of file branch.hpp.

## dispose()

template<class Merit>

size_t Gecode::FlatZinc::IntBoolBrancher< Merit >::dispose | ( | Space & | home | ) |

virtual

Delete brancher and return its size.

Reimplemented from Gecode::FlatZinc::IntBoolBrancherBase.

Definition at line 413 of file branch.hpp.

## Member Data Documentation

## merit

template<class Merit>

Merit Gecode::FlatZinc::IntBoolBrancher< Merit >::merit

protected

Selection by maximal merit.

Definition at line 306 of file branch.hh.

The documentation for this class was generated from the following files:

- gecode/flatzinc/branch.hh
- gecode/flatzinc/branch.hpp